----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    15:38:31 03/04/2008 
-- Design Name: 
-- Module Name:    one_hundred_K_counter - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity one_hundred_K_counter is
    Port ( clk : in  STD_LOGIC;
           rst : in  STD_LOGIC; -- active low
			  cken : in STD_LOGIC;
			  dout_fast : out STD_LOGIC; -- 256 count
           dout_100k : out  STD_LOGIC);
end one_hundred_K_counter;

architecture Behavioral of one_hundred_K_counter is

signal count : std_logic_vector (27 downto 0) := x"0000000";
signal co : std_logic := '0';
begin

process (clk, rst, count, cken)
begin
if (rst='0') then
  count <= (others=>'0');
elsif (cken ='1' and clk'event and clk='1') then
     if (count = x"002FAF0") then --roll-over to 0  2FAF080:50MHz=>1s
			  count <= (others=>'0');
			  co <= '1';
	  elsif (count = x"0017D78") then  --17D7840:50000000/2
			count <= count+1;
			co <= '0';
		else count <= count+1;
	   end if;
end if;
end process;

dout_100k  <= co;

dout_fast <= count(8); -- output a faster clock for use with the quad 7-segment display module

end Behavioral;

